
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Pango.Objects.Engine
    ( 

-- * Exported types
    Engine(..)                              ,
    EngineK                                 ,
    toEngine                                ,
    noEngine                                ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Pango.Types
import GI.Pango.Callbacks
import qualified GI.GObject as GObject

newtype Engine = Engine (ForeignPtr Engine)
foreign import ccall "pango_engine_get_type"
    c_pango_engine_get_type :: IO GType

type instance ParentTypes Engine = EngineParentTypes
type EngineParentTypes = '[GObject.Object]

instance GObject Engine where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_pango_engine_get_type
    

class GObject o => EngineK o
instance (GObject o, IsDescendantOf Engine o) => EngineK o

toEngine :: EngineK o => o -> IO Engine
toEngine = unsafeCastTo Engine

noEngine :: Maybe Engine
noEngine = Nothing

type instance AttributeList Engine = EngineAttributeList
type EngineAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList Engine = EngineSignalList
type EngineSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


