
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Pango.Objects.EngineLang
    ( 

-- * Exported types
    EngineLang(..)                          ,
    EngineLangK                             ,
    toEngineLang                            ,
    noEngineLang                            ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Pango.Types
import GI.Pango.Callbacks
import qualified GI.GObject as GObject

newtype EngineLang = EngineLang (ForeignPtr EngineLang)
foreign import ccall "pango_engine_lang_get_type"
    c_pango_engine_lang_get_type :: IO GType

type instance ParentTypes EngineLang = EngineLangParentTypes
type EngineLangParentTypes = '[Engine, GObject.Object]

instance GObject EngineLang where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_pango_engine_lang_get_type
    

class GObject o => EngineLangK o
instance (GObject o, IsDescendantOf EngineLang o) => EngineLangK o

toEngineLang :: EngineLangK o => o -> IO EngineLang
toEngineLang = unsafeCastTo EngineLang

noEngineLang :: Maybe EngineLang
noEngineLang = Nothing

type instance AttributeList EngineLang = EngineLangAttributeList
type EngineLangAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList EngineLang = EngineLangSignalList
type EngineLangSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


